Subject: bug#65345: guix-pull --list-generations is slow

From: Simon Tournier <[email-masked]>
Date: Thu, 24 Aug 2023 11:33:44 +0200

Hi,

On Wed, 16 Aug 2023 at 15:29, Olivier Dion <[email-masked]> wrote:

> $ time guix pull --list-generations > /dev/null
> real    0m58.702s
> user    1m8.418s
> sys     0m1.527s

On my poor laptop, it’s the same (14 Generations):

        $ time guix pull --list-generations >/dev/null

        real	1m2.201s
        user	1m0.021s
        sys	0m2.482s

And note before it was worse. ;-)

        $ time guix pull --list-generations --details > /dev/null

        real	1m57.606s
        user	2m6.575s
        sys	0m5.608s

> From a search in pull.scm, I think that the culprit is in the
> `channel-news-for-commit' procedure.

Well, as pointers, we discussed some part of this issue in:

    https://issues.guix.gnu.org/53909
    https://issues.guix.gnu.org/54000

And as I said in these past discussions, because the default behaviour
is very slow for me, I barely use these options.  I do not know if it
can be optimized or if another option for bypassing the news part should
be added.

Cheers,
simon